"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CryptoUtil = exports.Uint8ArrayStack = void 0;
var Uint8ArrayStack = /** @class */ (function () {
    function Uint8ArrayStack() {
        this.stack = new Uint8Array([]);
    }
    Object.defineProperty(Uint8ArrayStack.prototype, "length", {
        get: function () {
            return this.stack.byteLength;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * 入栈数据
     * @param uint8Array:Uint8Array
     * */
    Uint8ArrayStack.prototype.push = function (uint8Array) {
        var e_1, _a;
        var uint8Arrays = [this.stack, uint8Array];
        var size = uint8Arrays.reduce(function (total, next) { return total + next.byteLength; }, 0);
        var result = new Uint8Array(size);
        var offset = 0;
        try {
            for (var uint8Arrays_1 = __values(uint8Arrays), uint8Arrays_1_1 = uint8Arrays_1.next(); !uint8Arrays_1_1.done; uint8Arrays_1_1 = uint8Arrays_1.next()) {
                var uint8Array_1 = uint8Arrays_1_1.value;
                result.set(uint8Array_1, offset);
                offset += uint8Array_1.byteLength;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (uint8Arrays_1_1 && !uint8Arrays_1_1.done && (_a = uint8Arrays_1.return)) _a.call(uint8Arrays_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.stack = result;
    };
    /**
     * 出栈数据
     * @param len:number
     * */
    Uint8ArrayStack.prototype.readBytes = function (len) {
        if (len) {
            var outBytes = this.stack.subarray(0, len);
            this.stack = this.stack.subarray(len);
            return outBytes;
        }
        else {
            return null;
        }
    };
    return Uint8ArrayStack;
}());
exports.Uint8ArrayStack = Uint8ArrayStack;
/**
 * 加解密工具
 * */
var CryptoUtil = /** @class */ (function () {
    function CryptoUtil() {
    }
    CryptoUtil.ITER = 10000;
    CryptoUtil.DECRYPT_BLOCK_SIZE = 16 * 1024 * 64 * 2;
    CryptoUtil.AES_BLOCK_SIZE = 16;
    CryptoUtil.getKeyIv = function (content, password) {
        var salt = content.slice(8, 16);
        return CryptoUtil.getKeyAndIv(password, salt, 'decrypt');
    };
    CryptoUtil.decrypt = function (content, key, iv) {
        return window.crypto.subtle.decrypt({ name: "AES-CBC", iv: iv }, key, content);
    };
    CryptoUtil.chunkDecrypt = function (chunk, key, iv) { return __awaiter(void 0, void 0, void 0, function () {
        var nextIv, padding, uint8ArrayStack, paddedData, content;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    nextIv = chunk.subarray(chunk.byteLength - CryptoUtil.AES_BLOCK_SIZE);
                    return [4 /*yield*/, crypto.subtle.encrypt({
                            name: 'AES-CBC',
                            iv: nextIv
                        }, key, new Uint8Array(0))];
                case 1:
                    padding = _a.sent();
                    uint8ArrayStack = new Uint8ArrayStack();
                    uint8ArrayStack.push(chunk);
                    uint8ArrayStack.push(new Uint8Array(padding));
                    paddedData = uint8ArrayStack.readBytes(uint8ArrayStack.length);
                    return [4 /*yield*/, CryptoUtil.decrypt(paddedData, key, iv)];
                case 2:
                    content = _a.sent();
                    return [2 /*return*/, { chunkPlain: new Uint8Array(content), nextIv: nextIv }];
            }
        });
    }); };
    CryptoUtil.getKeyAndIv = function (password, salt, keyUsages) {
        if (keyUsages === void 0) { keyUsages = 'encrypt'; }
        return __awaiter(void 0, void 0, void 0, function () {
            var passphraseBytes, passwordBytes, passphraseKey, pbkdf2Bytes, keyBytes, ivBytes, key;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        passphraseBytes = new Uint8Array(32);
                        passwordBytes = new TextEncoder().encode(password).slice(0, 32);
                        passphraseBytes.set(passwordBytes);
                        return [4 /*yield*/, window.crypto.subtle.importKey('raw', passphraseBytes, { name: 'PBKDF2' }, false, ['deriveBits'])];
                    case 1:
                        passphraseKey = _a.sent();
                        return [4 /*yield*/, window.crypto.subtle.deriveBits({
                                name: 'PBKDF2',
                                salt: salt,
                                iterations: CryptoUtil.ITER,
                                hash: 'SHA-256'
                            }, passphraseKey, 384)];
                    case 2:
                        pbkdf2Bytes = _a.sent();
                        pbkdf2Bytes = new Uint8Array(pbkdf2Bytes);
                        keyBytes = pbkdf2Bytes.slice(0, 32);
                        ivBytes = pbkdf2Bytes.slice(32);
                        return [4 /*yield*/, window.crypto.subtle.importKey('raw', keyBytes, {
                                name: 'AES-CBC',
                                length: 256
                            }, false, ['encrypt', 'decrypt'])];
                    case 3:
                        key = _a.sent();
                        return [2 /*return*/, {
                                key: key,
                                iv: ivBytes
                            }];
                }
            });
        });
    };
    return CryptoUtil;
}());
exports.CryptoUtil = CryptoUtil;
