"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("./common");
var zip_1 = __importDefault(require("./zip"));
/**
 * 文件名：FileSaveRegister
 * 作　者：Bryce.Li
 * 创　建：2021/6/16 11:28
 * 描　述：Bryce.Li
 * */
var FileSaveRegister = /** @class */ (function () {
    function FileSaveRegister(scope, options) {
        var _this = this;
        if (scope === void 0) { scope = '/'; }
        if (options === void 0) { options = {
            confirmMessage: '',
            onMessage: function (data) {
            }
        }; }
        this.options = options;
        this.aborterMap = {};
        this.progressMap = {};
        this.completeMap = {};
        this.errorMap = {};
        this.active = false;
        // 注册service worker，并初始化逻辑
        if ('serviceWorker' in navigator) {
            navigator.serviceWorker.register('/sswa-sw.js', { scope: scope }).then(function (swReg) {
                if (swReg.installing) {
                    window.location.reload();
                }
                else if (swReg.active) {
                    _this.active = true;
                    return swReg;
                }
                return Promise.reject();
            }).then(function (reg) {
                var messageChannel = new MessageChannel();
                reg.active.postMessage("SW_INIT", [messageChannel.port2]);
                _this.messagePort = messageChannel.port1;
                // keepAlive 保存sw存活，firefox在30s后会关闭不活动的service worker
                // 通过postMessage ping pong方式使其不被关闭
                setInterval(function () { return reg.active.postMessage('ping'); }, 10000);
            }).then(function () {
                _this.messagePort.onmessage = _this._getMessage.bind(_this);
            }).catch(function (err) {
            });
        }
        // 刷新或关闭页面时，清除\取消 所有下载任务
        window.addEventListener('beforeunload', function () { return _this.abort('user refresh page'); });
    }
    /**
     *  下载文件
     *  @param {string} filename 文件名
     *  @param {string | {name:string,url:string}[]} url
     *  @param {number} size 文件总大小 byte
     *  @param options
     * */
    FileSaveRegister.prototype.download = function (filename, url, size, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        if (this.active) {
            var uuid_1 = Math.random().toString().slice(-10);
            this.aborterMap[uuid_1] = null;
            this.messagePort.postMessage({
                type: 'DOWNLOAD_REGISTER', uuid: uuid_1, url: url, filename: filename, size: size, password: options.password
            });
            options.cancel && options.cancel(function () {
                _this.abort('cancel by canceler', uuid_1);
            });
            this.progressMap[uuid_1] = function (loaded) {
                options.onProgress && options.onProgress(loaded, size);
            };
            this.completeMap[uuid_1] = function () {
                options.onComplete && options.onComplete();
            };
            this.errorMap[uuid_1] = function (message) {
                options.onError && options.onError(message);
            };
        }
        else {
            console.error('service worker is not register or active');
            var bl = confirm(this.options.confirmMessage || 'sw服务未注册或激活，是否立即刷新浏览器？');
            if (bl)
                window.location.reload();
        }
    };
    /**
     * 终止下载
     * @param {string} message
     * @param {string} uuid
     * @return {boolean} 是否终止成功
     * */
    FileSaveRegister.prototype.abort = function (message, uuid) {
        if (uuid === void 0) { uuid = null; }
        if (uuid) {
            if (this.aborterMap[uuid]) {
                this.aborterMap[uuid](message);
                return true;
            }
        }
        else {
            for (var uuid_2 in this.aborterMap) {
                this.abort('user refresh page', uuid_2);
            }
        }
        return false;
    };
    /**
     *  MessageChannel 监听事件
     *  @param {MessageEvent} event
     * */
    FileSaveRegister.prototype._getMessage = function (event) {
        var _a = event.data, url = _a.url, type = _a.type, uniqLink = _a.uniqLink, uuid = _a.uuid, password = _a.password;
        this.options.onMessage && this.options.onMessage(event.data);
        if (type === 'DOWNLOAD_REGISTER_SUCCESS') {
            var iframe_1 = document.createElement("iframe");
            iframe_1.src = uniqLink;
            iframe_1.hidden = true;
            document.body.appendChild(iframe_1);
            setTimeout(function () { return document.body.removeChild(iframe_1); }, 1000);
            if (Array.isArray(url)) {
                this._batchFetchFile(url, uniqLink, uuid, password);
            }
            else {
                this._fetchFile(url, uniqLink, uuid, password);
            }
        }
        else if (type === 'USER_CANCEL_DOWNLOAD') {
            this.abort('cancel by browser', uuid);
        }
    };
    /**
     * 连接 stream 数据流
     * @param {string} uniqLink:string
     * @param {number} uuid:number
     * @param {ReadableStream} readableStream
     * @param {string} password
     * @param zip
     * */
    FileSaveRegister.prototype._pipStream = function (uniqLink, uuid, readableStream, password, zip) {
        var _this = this;
        if (zip === void 0) { zip = false; }
        var loaded = 0;
        var reader = readableStream.getReader();
        this.messagePort.postMessage({ type: 'DOWNLOAD_START', uniqLink: uniqLink });
        var pump = function () { return reader.read().then(function (res) {
            if (res.done) {
                _this.messagePort.postMessage({ type: 'DOWNLOAD_END', uniqLink: uniqLink });
                _this.completeMap[uuid]();
            }
            else {
                var chunk = res.value;
                loaded += chunk.length;
                _this.messagePort.postMessage({ type: 'DOWNLOADING', chunk: chunk, uniqLink: uniqLink, uuid: uuid, password: password, zip: zip });
                _this.progressMap[uuid](loaded);
                pump();
            }
        }); };
        pump();
    };
    /**
     * 增强 Fetch，具有中断及解密功能
     * _fetch
     * @param {string} url
     * @param {string} password
     * @param {string} uuid
     * @param options
     * @returns {Promise}
     * */
    FileSaveRegister.prototype._fetch = function (url, password, uuid, options) {
        var _this = this;
        var abort = options.canceler || function () {
        };
        var uint8ArrayStack = new common_1.Uint8ArrayStack();
        var abortHandler = function (res) {
            var reader = res.body.getReader();
            var stream = new ReadableStream({
                start: function (controller) {
                    var aborted = false, keyIV;
                    var push = function () { return __awaiter(_this, void 0, void 0, function () {
                        var _a, value, done, loopDecrypt_1, inBytes, plain, e_1, err_1;
                        var _this = this;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _b.trys.push([0, 12, , 13]);
                                    return [4 /*yield*/, reader.read()];
                                case 1:
                                    _a = _b.sent(), value = _a.value, done = _a.done;
                                    if (!!done) return [3 /*break*/, 5];
                                    if (!password) {
                                        controller.enqueue(value);
                                        push();
                                        return [2 /*return*/];
                                    }
                                    uint8ArrayStack.push(value);
                                    loopDecrypt_1 = function () { return __awaiter(_this, void 0, void 0, function () {
                                        var inBytes, _a, chunkPlain, nextIv;
                                        return __generator(this, function (_b) {
                                            switch (_b.label) {
                                                case 0:
                                                    if (!(uint8ArrayStack.length > common_1.CryptoUtil.DECRYPT_BLOCK_SIZE)) return [3 /*break*/, 3];
                                                    inBytes = uint8ArrayStack.readBytes(common_1.CryptoUtil.DECRYPT_BLOCK_SIZE);
                                                    return [4 /*yield*/, common_1.CryptoUtil.chunkDecrypt(inBytes, keyIV.key, keyIV.iv)];
                                                case 1:
                                                    _a = _b.sent(), chunkPlain = _a.chunkPlain, nextIv = _a.nextIv;
                                                    try {
                                                        controller.enqueue(chunkPlain);
                                                    }
                                                    catch (e) {
                                                    }
                                                    keyIV.iv = nextIv;
                                                    return [4 /*yield*/, loopDecrypt_1()];
                                                case 2:
                                                    _b.sent();
                                                    return [3 /*break*/, 4];
                                                case 3:
                                                    push();
                                                    _b.label = 4;
                                                case 4: return [2 /*return*/];
                                            }
                                        });
                                    }); };
                                    if (!(uint8ArrayStack.length >= common_1.CryptoUtil.AES_BLOCK_SIZE && !keyIV)) return [3 /*break*/, 3];
                                    inBytes = uint8ArrayStack.readBytes(common_1.CryptoUtil.AES_BLOCK_SIZE);
                                    return [4 /*yield*/, common_1.CryptoUtil.getKeyIv(inBytes, password)];
                                case 2:
                                    keyIV = _b.sent();
                                    _b.label = 3;
                                case 3: return [4 /*yield*/, loopDecrypt_1()];
                                case 4:
                                    _b.sent();
                                    return [3 /*break*/, 11];
                                case 5:
                                    if (!!aborted) return [3 /*break*/, 11];
                                    if (!password) {
                                        controller.close();
                                        return [2 /*return*/];
                                    }
                                    if (!(uint8ArrayStack.length > 0)) return [3 /*break*/, 10];
                                    _b.label = 6;
                                case 6:
                                    _b.trys.push([6, 8, , 9]);
                                    return [4 /*yield*/, common_1.CryptoUtil.decrypt(uint8ArrayStack.readBytes(uint8ArrayStack.length), keyIV.key, keyIV.iv)];
                                case 7:
                                    plain = _b.sent();
                                    controller.enqueue(new Uint8Array(plain));
                                    controller.close();
                                    return [3 /*break*/, 9];
                                case 8:
                                    e_1 = _b.sent();
                                    // 解密失败捕获-abort
                                    this.abort('decrypt error', uuid);
                                    return [3 /*break*/, 9];
                                case 9: return [3 /*break*/, 11];
                                case 10:
                                    controller.close();
                                    _b.label = 11;
                                case 11: return [3 /*break*/, 13];
                                case 12:
                                    err_1 = _b.sent();
                                    this.abort(err_1, uuid);
                                    return [3 /*break*/, 13];
                                case 13: return [2 /*return*/];
                            }
                        });
                    }); };
                    abort(function () {
                        reader.cancel();
                        controller.error('forced interrupt fetch');
                        aborted = true;
                    });
                    push();
                }
            });
            return new Response(stream, { headers: res.headers });
        };
        return fetch(url).then(abortHandler);
    };
    /**
     * _fetchFile
     * 单文件下载
     * @param {string} url
     * @param {string} uniqLink
     * @param {string} uuid
     * @param {string} password
     * */
    FileSaveRegister.prototype._fetchFile = function (url, uniqLink, uuid, password) {
        var _this = this;
        this._fetch(url, password, uuid, {
            canceler: function (canceler) {
                _this.aborterMap[uuid] = function (message) {
                    if (message === void 0) { message = 'abort'; }
                    canceler();
                    _this.messagePort.postMessage({ uniqLink: uniqLink, type: 'DOWNLOAD_ABORT' });
                    _this.errorMap[uuid](message);
                };
            }
        }).then(function (response) {
            var readableStream = response.body;
            _this._pipStream(uniqLink, uuid, readableStream, password);
        }).catch(function (err) {
            if (!_this.abort(uuid, err)) {
                _this.messagePort.postMessage({ uniqLink: uniqLink, type: 'DOWNLOAD_ABORT' });
                _this.errorMap[uuid](err);
            }
        });
    };
    /**
     * _batchFetchFile
     * @param {{name:string,url:string}[]} fileList
     * @param {string} uniqLink
     * @param {string} uuid
     * @param password
     * */
    FileSaveRegister.prototype._batchFetchFile = function (fileList, uniqLink, uuid, password) {
        var _this = this;
        var fetchCanceler;
        var files = fileList.map(function (item) { return [item.path, item.url]; }).values();
        // @ts-ignore
        var _a = new zip_1.default({
            pull: function (ctrl) {
                var it = files.next();
                if (it.done) {
                    ctrl.close();
                }
                else {
                    // TODO 这里直接捕获了异常是否影响pull
                    var _a = __read(it.value, 2), name_1 = _a[0], url = _a[1];
                    return _this._fetch(url, password, uuid, {
                        canceler: function (canceler) { return fetchCanceler = canceler; }
                    }).then(function (res) {
                        ctrl.enqueue({ name: name_1, stream: function () { return res.body; } });
                    }).catch(function (err) {
                        if (!_this.abort(uuid, err)) {
                            _this.messagePort.postMessage({ uniqLink: uniqLink, type: 'DOWNLOAD_ABORT' });
                            _this.errorMap[uuid](err);
                        }
                    });
                }
            }
        }), readableZipStream = _a.readableZipStream, abort = _a.abort;
        this.aborterMap[uuid] = function (message) {
            if (message === void 0) { message = 'abort'; }
            abort();
            fetchCanceler();
            _this.messagePort.postMessage({ uniqLink: uniqLink, type: 'DOWNLOAD_ABORT' });
            _this.errorMap[uuid](message);
        };
        this._pipStream(uniqLink, uuid, readableZipStream, password, true);
    };
    return FileSaveRegister;
}());
exports.default = FileSaveRegister;
